/**********************************************************************************/
/* Erstes kleines Testprogramm um einen CM119 anzusteuern  20.10.2009             */
/*                                                                                */
/* Das funktioniert natuerlich nur wenn vorher libusb installiert wurde!          */
/* Ausserdem installiert Linux beim anstecken des CM119 seinen hidusb Treiber     */
/* Der muss entfernt werden!                                                      */
/* Besser waere es wohl wenn man das IC im Kernel Blacklisten wuerde.             */
/**********************************************************************************/

#include <stdio.h>
#include <usb.h> 
#include "cm119.h"

/* Deviceabhaengige Daten */
#define VENDOR 0x0d8c         /* VendorID des CM119     */
#define PID    0x000c         /* ProduktID              */
#define INTERFACE_NUMBER 0x03 /* bIntefaceNumber: 3     */


struct usb_bus *busses;
struct usb_ctrlrequest *ctl_req;


/* Datenblock zum Austausch von Bytes mit dem CM119 */
typedef unsigned char CM119Type[4];

       

/**********************************************************************************/
/* Sucht unser Device und liefert die notwendigen Zeiger zurueck                  */
/**********************************************************************************/
struct usb_device* find_device(int vendor, int pid, int n)
{
        struct usb_bus *bus;
        struct usb_device *dev;
        
        usb_init ();
        usb_find_busses ();
        usb_find_devices ();

        fprintf(stderr, "Looking for USB device (vendor 0x%x, product 0x%x)...\n",vendor, pid);
         for (bus = usb_busses; bus; bus = bus->next) 
         {
                 dev = bus->devices;
                 if (dev)
                         for (dev = bus->devices; dev; dev = dev->next) 
                         {
                                 if ((dev->descriptor.idVendor == vendor) &&
                                     (dev->descriptor.idProduct == pid))
                                 {
                                         if (n==0) { fprintf(stderr,"found.\n"); return dev; }
                                         else { n--;  continue; }
                                 }
                         }
         }
         fprintf(stderr,"NOT FOUND!\n");
         return NULL;
}





/**********************************************************************************/
/* Liest die Input-Register vom cm119                                             */
/**********************************************************************************/
int Lese_Input_Register(usb_dev_handle *devh, CM119Type data) 
{
  int ret;

     ret = usb_control_msg( devh,                               /* Device Handle */
			    USB_ENDPOINT_IN + USB_TYPE_CLASS + USB_RECIP_INTERFACE,
			    HID_REPORT_GET,
			    (HID_RT_INPUT << 8),                 /* Welche Daten wollen wir lesen wValue */
			    INTERFACE_NUMBER,                   /* wIndex = bInterfacenumber*/
			    data,                                /* Hier stehen unsere Daten */
                            4,                                  /* Wieviel Bytes wollen wir lesen */
                            100);                              /* Wartezeit bis Antwort in ms */

  return ret;
}


/**********************************************************************************/
/* Liest die Outputregister des CM119 zurueck                                     */
/**********************************************************************************/
int Lese_Output_Register(usb_dev_handle *devh, CM119Type data) 
{
  int ret;

     ret = usb_control_msg( devh,                               /* Device Handle */
			    USB_ENDPOINT_IN + USB_TYPE_CLASS + USB_RECIP_INTERFACE,
			    HID_REPORT_GET,
			    (HID_RT_OUTPUT << 8),      /* Welche Daten wollen wir lesen wValue */
			    INTERFACE_NUMBER,                                  /* wIndex = bInterfacenumber*/
			    data,                                /* Hier stehen unsere Daten */
                            4,                                  /* Wieviel Bytes wollen wir lesen */
                            100);                              /* Wartezeit bis Antwort in ms */



  return ret;
}



/**********************************************************************************/
/* Uebergebenen Buffer von genau 4Byte Laenge an den CM119 schicken               */
/**********************************************************************************/
int Schreibe_OR(usb_dev_handle *devh, CM119Type data) 
{
  int ret;

 
     ret = usb_control_msg( devh,                               /* Device Handle */
			    USB_ENDPOINT_OUT + USB_TYPE_CLASS + USB_RECIP_INTERFACE,
			    HID_REPORT_SET,
			    (HID_RT_OUTPUT << 8),      /* Welche Daten wollen wir lesen wValue */
			    INTERFACE_NUMBER,                                  /* wIndex = bInterfacenumber*/
			    data,                                /* Hier stehen unsere Daten */
                            4,                                  /* Wieviel Bytes wollen wir lesen */
                            100);                              /* Wartezeit bis Antwort in ms */


  return ret;
}



/**********************************************************************************/
/* Leuchtdiode an GPIO8 Pin22 blinken lassen                                      */
/**********************************************************************************/
void blinki(usb_dev_handle *devh)
{ int i;


 CM119Type cm119buf;

 cm119buf[0] = 0x00;
 cm119buf[1] = 0x80;  /* GPIO8 auf High setzen */
 cm119buf[2] = 0x80;  /* GPIO8 als Ausgang verwenden */
 cm119buf[3] = 0x00;
 
 for(i=0;i<10;i++)
 {
   
   cm119buf[1] = 0x80;  /* GPIO8 auf High setzen */
   if ( Schreibe_OR(devh,cm119buf) <0) printf("Fehler beim Schreiben der Outputregister \n");
   usleep(200000);


   cm119buf[1] = 0x00;  /* GPIO8 auf Low setzen */
   if ( Schreibe_OR(devh,cm119buf) <0) printf("Fehler beim Schreiben der Outputregister \n");
   usleep(200000);
 }

}








/**********************************************************************************/
/* Hauptprogramm                                                                  */
/**********************************************************************************/
main(int argc, char *argv[])
{
  struct usb_bus *bus;
  struct usb_device *dev;
  usb_dev_handle *devh;


  CM119Type cm119buf;


  /* Sucht das Device und liefert bei Erfolg einen Zeiger darauf zurueck */
  /* Sollte kein Device gefunden werden wird NULL zurueckgegeben */
  dev = find_device(VENDOR,PID,0);


  if (dev!=NULL)
    {

      if ((dev->descriptor.idVendor == VENDOR) &&
	  (dev->descriptor.idProduct == PID))
	     printf("C-Media CM-119 gefunden\n");

      /* Also das Device auch oeffnen */
      devh=usb_open(dev);

      if(devh!=0)
	{
	  printf("Das Device ist nun offen.\n");

	  /* Nun muessen wir unbedingt das Interface begrabbeln */
	  if (usb_claim_interface(devh,INTERFACE_NUMBER) <0) {
	    printf("Das Interface %i ist nicht verfuegbar!\n",INTERFACE_NUMBER);
	    printf("Bist du auch root?\n");
	    printf("Wird das Interface schon vom Kernel genutzt? (rmmod usbhid) \n");
	    usb_close(devh);
	    return;
	  };
	     
	  /* Wenn wir bis hier gekommen sind, dann kann das Device nun benutzt werden */




	  /* Vorsicht! Wenn ich das Datenblatt richtig verstehe kann man hier auch */
	  /* durch falsche Daten den Inhalt des EEPROM veraendern.                 */
	  cm119buf[0] = 0x00;
	  cm119buf[1] = 0x80;  /* GPIO8 auf High setzen */
	  cm119buf[2] = 0x80;  /* GPIO8 als Ausgang verwenden */
	  cm119buf[3] = 0x00;
	  if ( Schreibe_OR(devh,cm119buf) <0) printf("Fehler beim Schreiben der Outputregister \n");



	  if ( Lese_Input_Register(devh,cm119buf)  <0) printf("Fehler beim Lesen der Inputregister \n");
	  else
	    printf("\nHID_IR0: %02xh\nHID_IR1: %02xh\nHID_IR2: %02xh\nHID_IR3: %02xh\n\n",
		   cm119buf[0],cm119buf[1],cm119buf[2],cm119buf[3]);



	  if ( Lese_Output_Register(devh,cm119buf) <0) printf("Fehler beim Lesen des OutputRegister \n");
	  else
	    printf("\nHID_OR0: %02xh\nHID_OR1: %02xh\nHID_OR2: %02xh\nHID_OR3: %02xh\n\n",
		   cm119buf[0],cm119buf[1],cm119buf[2],cm119buf[3]);

	     

	  printf("Jetzt sollte eine LED an GPIO8 blinken\n");
	  blinki(devh);


	} 
      else
	{
	  printf("Es gibt ein Problem beim oeffnen des Devices\n");
	  return;
	};

      printf("Alles erfolgreich, Device wird geschlossen und Programm beendet\n");
      usb_close(devh);
    }   
}

