
#define USB_CLASS_AUDIO 1
#define USB_CLASS_COMM  2
#define USB_CLASS_HID   3

/* USB Types */
#define USB_TYPE_MASK      (0x03 << 5)
#define USB_TYPE_STANDARD  (0x00 << 5)
#define USB_TYPE_CLASS     (0x01 << 5)
#define USB_TYPE_VENDOR    (0x02 << 5)
#define USB_TYPE_RESERVED  (0x03 << 5)



/*  USB recipients */
#define USB_RECIP_MASK0x1f
#define USB_RECIP_DEVICE0x00
#define USB_RECIP_INTERFACE0x01
#define USB_RECIP_ENDPOINT0x02
#define USB_RECIP_OTHER0x03


/* USB directions */
#define USB_DIR_OUT     0
#define USB_DIR_IN      0x80




/* HID Register */
#define  HID_IR0 0x00 /* Record/Playback-mute button, Volume up/down  */
#define  HID_IR1 0x01 /* GPI, generic registers or EEPROM_DATA0       */
#define  HID_IR2 0x02 /* Generic registers or EEPROM_DATA1            */
#define  HID_IR3 0x03 /* Generic registers or EEPROM_CTRL             */
#define  HID_OR0 0x00 /* Mapping control, buzzer, SPDIF (offset 0x04) */
#define  HID_OR1 0x01 /* GPO - General Purpose Output                 */
#define  HID_OR2 0x02 /* Set GPIO to input/output mode                */
#define  HID_OR3 0x03 /* SPDIF status channel or EEPROM_CTRL          */


#define HID_REPORT_GET 0x01
#define HID_REPORT_SET 0x09

#define HID_GET_IDLE   0x02
#define HID_SET_IDLE   0x0A

#define HID_RT_INPUT   0x01
#define HID_RT_OUTPUT  0x02
#define HID_RT_FEATURE 0x03


